<?php
   /*
   AtomPhotoBlog.class.php
   AtomPhotoBlog Core Class
   Version 1.1.5b1 
   Copyright (C) 2007 by Sascha Tayefeh
   http://www.tayefeh.de

   Smarty(TM) is not part of this code, but is maintained by 
   New Digital Group, Inc. and copyright 2001-2005 New Digital Group, Inc.
   See http://smarty.php.net/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
   */

   /*!
   The main class: AtomPhotoBlog::

   CLASS-HIERARCHY:

   MySQL.class <- MySQLPhoto.class <- AtomPhotoBlog.class
   */

   require_once './apbClasses/templateFileNames.inc.php';
   require_once './apbClasses/MySQLPhoto.class.php';
   require_once './apbClasses/Admin.class.php';
   require_once './apbData/salt.php';
   require_once './apbClasses/CheckContent.php';
   require_once './apbClasses/FeedRss.php';
   require_once './apbClasses/FeedAtom.php';
   require_once './apbClasses/codeCleaner.inc.php';
   require_once './apbClasses/resizeImage.inc.php';

   class AtomPhotoBlog extends MySQLPhoto
   {
      // ---------- Properties
      public $rootPath=".";
      public $rootUrl="http://localhost/";
      public $picPath="http://localhost/blog";
      public $picUrl="http://localhost/blog";
      public $blogDescription="BlaBla";
      public $blogTitle="Atom Photo Blog";
      public $blogSubTitle="An object-oriented Photo-Blog based on Atom Web-Feeds";
      public $blogOwner="Nobody";
      public $blogOwnerEmail="Nobody@nowhere.nocom";
      public $mainScript="atomPhotoBlog.php";
      public $atomFile="./blog/atom.xml";
      public $atomFileUrl="http://localhost/blog/atom.xml";
      public $rssFile="./blog/rss.xml";
      public $rssFileUrl="http://localhost/blog/rss.xml";
      public $htmlEncoding="ISO-8859-15";
      public $maxRows=4;
      public $maxCols=4;
      public $largeImageWidth=800;
      public $largeImageHeight=600;
      public $thumbnailWidth=141;
      public $thumbnailHeight=94;
      public $jpegQuality=85;
      public $embedCopyright=TRUE;
      public $doSession=TRUE; // Send cookies?
      public $isSessionStarted=FALSE; // Was a session requested?
      public $showTitleInIndex=FALSE; // Show the title in the index-table?
      public $styleSheet='./apbCss/atomPB.css'; // The Style-Sheet

      private $fileName;
      private $target;
      private $targetTn;
      private $targetUrl;
      private $targetTnUrl;

      /*
      Features all ids'n stuff necessary for
      the navigator-method (the next/prev-button stuff)
      $navi['thisId']= picId of currently selected picture
      $navi['oldestId']= oldest picture
      $navi['prevId']= previouse picture
      $navi['nextId']= next picture
      $navi['latestId']= latest picture
      $navi['tagLink']= was a tag selected? if yes, say so
      */
      private $navi=array();

      /*
      All navigation variables are tarsfered using the GET-Method, thus,
      all parameters start witg "get".  
      */
      public $getMode="default";
      public $getDo="default";
      public $getPhotoId=-1; // Default foto Id=-1 is interpreted as "latest picture"
      public $getTag=FALSE;

      private $admin; // Admin object derived from Admin.class.php
      public $access=FALSE; // access granted flag


      /* NEW PROPERTIES since V1.0.9.2 */
      private $rssProperties=array();
      private $atomProperties=array();
      private $smartyDir="";

      /*!
      This method stores all GETS/POSTS in private members of this object.
      */
      public function getVarsFromBrowser()
      {

	 // XSS ATTACK?!?
	 foreach ($_GET as $item => $value) { if (preg_match("/[^a-zA-Z0-9 ,]/i",$value)) 
	   die("*** ERROR: Invalid usage of var $item, possible XSS attack!"); }

	 // Use a whitelist to set vars
	 if(isset($_GET['mode'])) $this->getMode=$_GET['mode'];
	 if(isset($_POST['mode'])) $this->getMode=$_POST['mode'];
	 if(isset($_GET['do'])) $this->getDo=$_GET['do'];
	 if(isset($_POST['do'])) $this->getDo=$_POST['do'];
	 if(isset($_GET['photoId'])) $this->getPhotoId=$_GET['photoId'];
	 if(isset($_GET['tag'])) $this->getTag=$_GET['tag'];

	 return;
      }

      /*!
      Just save the vars obtained from Options-Form. No errorcheck, just save.
      This private method is used by ::saveSettings().
      */
      private function saveVars()
      {
	 foreach( $_POST  as $key => $value) $apbPara[$key]= $value;

	 $apbPara['blogOwner']=xmlRecodeLight($apbPara['blogOwner']);
	 $apbPara['blogTitle']=xmlRecodeLight($apbPara['blogTitle']);
	 $apbPara['blogSubTitle']=xmlRecodeLight($apbPara['blogSubTitle']);

	 $fp=fopen('./apbData/vars.php',"w+") or die("Could not write Logfile");

	 $buf ='<?php'."\n";
	    $buf .='$apbPara=array('."\n";
	    foreach( $apbPara as $key => $value)
	    {
	      // echo "$key = $value<br/>";
	       
	       $value=str_replace('"','\"',$value);
	       if (
		  $key!="do" &&
		  $key!="adLg" &&
		  $key!="adPw" &&
		  $key!="adPwRep" &&
		  $key!="mysqlPasswdRep" &&
		  $key!="embedCopyright"
	       ) $buf .= "\t\"$key\"\t=>\"$value\",\n";
	    }
	    if ($apbPara['showTitleInIndex']=="Yes") $buf .= "\t\"showTitleInIndex\"\t=> TRUE, \n";
	    else $buf .= "\t\"showTitleInIndex\"\t=> FALSE, \n";
	    if ($apbPara['embedCopyright']=="Yes") $buf .= "\t\"embedCopyright\"\t=> TRUE\n";
	    else $buf .= "\t\"embedCopyright\"\t=> FALSE\n";
	    $buf.= ");\n";
	 $buf.= "\n?>\n";

	 fwrite($fp,$buf);
	 fclose($fp);
      }

      /*!
      Errorcheck and save variables obtained from settings-form.
      */
      private function saveSettings()
      {
	 $nErrors=0;
	 $error=NULL;
	 $img['errorOccured']=FALSE;

	 // Errorcheck
	 $error['largeImageWidth']=$this->validEntry('largeImageWidth','/[^0-9]/',"MUST BE A DIGIT");
	 $error['largeImageHeight']=$this->validEntry('largeImageHeight','/[^0-9]/',"MUST BE A DIGIT");
	 $error['thumbnailWidth']=$this->validEntry('thumbnailWidth','/[^0-9]/',"MUST BE A DIGIT");
	 $error['thumbnailHeight']=$this->validEntry('thumbnailHeight','/[^0-9]/',"MUST BE A DIGIT");
	 $error['jpegQuality']=$this->validEntry('jpegQuality','/[^0-9]/',"MUST BE A DIGIT");
	 // $error['maxRows']=$this->validEntry('maxRows','/[^0-9]/',"MUST BE A DIGIT");

	 $error['maxCols']=$this->validEntry('maxCols','/[^0-9]/',"MUST BE A DIGIT");
	 $error['blogOwner']=$this->validEntry('blogOwner','/[^a-zA-Z\. ]/',"MUST BE A LETTER");

	 if (isset($_POST['blogOwnerEmail']) && !preg_match('/^[^@\s]+@([-a-z0-9]+\.)+[a-z]{2,}$/i',trim($_POST['blogOwnerEmail'])))
	 $error['blogOwnerEmail']=$_POST['blogOwnerEmail']." MUST BE A VALID E-MAIL";

	 if (isset($_POST['adLg']) && preg_match('/[^a-z0-9 ]/i',trim($_POST['adLg'])))
	 $error['adLg']="Invalid name: Only letters and numbers allowed";

	 if ( (isset($_POST['adPw']) && isset($_POST['adPwRep'])) && $_POST['adPw'] != $_POST['adPwRep'] )
	 $error['adPwRep']="Invalid admin password: Passwords do not equal!";

	 if ( $_POST['mysqlPasswd'] != $_POST['mysqlPasswdRep'] )
	 $error['mysqlPasswdRep']="Invalid MySQL password: Passwords do not equal!";

	 if ( (isset($_POST['blogTitle']) && trim($_POST['blogTitle'])=="") )
	 $error['blogTitle']="Invalid title: Title is empty?!";

	 if ( (isset($_POST['mysqlSrv']) && trim($_POST['mysqlSrv'])=="") )
	 $error['mysqlSrv']="Invalid Mysql-Server: Mysql-Server MUST NOT BE EMPTY!";

	 if ( (isset($_POST['mysqlDb']) && trim($_POST['mysqlDb'])=="") )
	 $error['mysqlDb']="Invalid Mysql-Database: Mysql-Database MUST NOT BE EMPTY!";

	 if ( (isset($_POST['mysqlLogin']) && trim($_POST['mysqlLogin'])=="") )
	 $error['mysqlLogin']="Invalid Mysql-Login: Mysql-Loginname MUST NOT BE EMPTY!";

	 if(isset($error))
	 {
	    foreach ($error as $key => $value)
	    { 
	       if ($error[$key])
	       {
		  $img['error'][$key]=$value;
		  $nErrors++;
		  }
	    }
	    if ($nErrors>0)  $img["errorOccured"]=TRUE;
	 }

	 $img["nErrors"]=$nErrors;

	 // ********** Save
	 // Save Admin login
//	 if (trim($_POST['adLg']!="" && trim($_POST['adPw']!="")))  $this->admin->savePw($_POST['adLg'],$_POST['adPw'])  ;


	 // Save Vars
	 $this->saveVars();

	 return $img;
      }

      private function validEntry($envVar,$regExp,$myError)
      {
	 $error=FALSE;
	 if ( (isset($_POST[$envVar]) && trim($_POST[$envVar])=="") ) $error="MUST NOT BE EMPTY";
	 elseif (preg_match($regExp,trim($_POST[$envVar]))) $error=$myError;
	 return $error;
      }

      /*!
      Print the Settings-Form.
      */
      public function printSettingsForm()
      {
	 $img['error']=FALSE;
	 if ($this->accessError()) return $img['error']=TRUE;

	 $img['blogOwner']=$this->blogOwner;
	 $img['blogOwnerEmail']=$this->blogOwnerEmail;
	 $img['mysqlServer']=$this->mysqlServer;
	 $img['mysqlLogin']=$this->mysqlLogin;
	 $img['mysqlPasswd']=$this->mysqlPasswd;
	 $img['mysqlDb']=$this->mysqlDb;
	 $img['blogTitle']=$this->blogTitle;
	 $img['blogSubTitle']=$this->blogSubTitle;
	 $img['largeImageWidth']=$this->largeImageWidth;
	 $img['largeImageHeight']=$this->largeImageHeight;
	 $img['thumbnailWidth']=$this->thumbnailWidth;
	 $img['thumbnailHeight']=$this->thumbnailHeight;
	 $img['jpegQuality']=$this->jpegQuality;
	 $img['maxRows']=$this->maxRows;
	 $img['maxCols']=$this->maxCols;
	 $img['styleSheet']=$this->styleSheet;
	 $img['embedCopyright']=$this->embedCopyright;
	 $img['showTitleInIndex']=$this->showTitleInIndex;
	 $img['htmlEncoding']=$this->htmlEncoding;
	 $img['rootPath']=$this->rootPath;
	 $img['rootUrl']=$this->rootUrl;
	 $img['picPath']=$this->picPath;
	 $img['picUrl']=$this->picUrl;
	 $img['atomFile']=$this->atomFile;
	 $img['atomFileUrl']=$this->atomFileUrl;
	 $img['rssFile']=$this->rssFile;
	 $img['rssFileUrl']=$this->rssFileUrl;
	 $img['smartyDir']=$this->smartyDir;

	 return $img;
      }

      public function selectTemplateContent()
      {
	 $ok=TRUE;
	 $ret=array();

	 switch ($this->getDo)
	 {
	    case "options": // Open admin's options menu
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->printSettingsForm());
		  $ret['template']=BLOG_SETTINGS_FORM; 
	       }
	       break;
	    case "edit": // Open admin's edit menu
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->printEditForm($this->getPhotoId));
		  $ret['template']=EDIT_PICTURE_FORM; 
	       }
	       break;
	    case "doEdit": // Open admin's edit menu
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->editPicture());
		  $ret['template']=EDIT_PICTURE_RESPONSE; 
	       }
	       break;
	    case "delete": // Open admin's deletion menu
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->deletePicture($this->getPhotoId));  
		  $ret['template']=DELETE_PICTURE_RESPONSE; 
	       }
	       break;
	    case "upload": // Open admin's upload menu
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->printUploadForm());  
		  $ret['template']=UPLOAD_PICTURE_FORM; 
	       }
	       break;
	    case "appComs": // Open admin's comment-approve menu
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->approveComments());  
		  $ret['template']=APPROVE_COMMENTS; 
	       }
	       break;
	    case "pwDone": // Password was sent by form, check it
	       $ret['assign']=array('img' => $this->admin->checkPw($_POST['username'],$_POST['password']));
	       $ret['template']=LOGIN_RESPONSE; 
	       break;
	    case "logout": // Print the admin-logout form
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $this->admin->logout();
		  $ret['template']=LOGOUT_RESPONSE; 
	       }
	       break;
	    case "login": // Print the admin-login form
	       $ret['assign']=array('img' => $this->admin->login());
	       $ret['template']=LOGIN_FORM; 
	       break;
	    case "about": // Print the admin-login form
	       $ret['template']=ABOUT_PAGE; 
	       break;
	    case "doApprove": // Admin has approved comments. Now proceed.
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->doApprove());  
		  $ret['template']=APPROVE_COMMENTS_RESPONSE;
	       }
	       break;
	    case "comment": // User has send comment, put into approval-queue
	       $ok=$this->saveComment();
	       $ret['assign']=array('img' => $this->saveComment());  
	       $ret['template']=USER_COMMENT_RESPONSE; 
	       break;
	    case "saveSettings": // Admin has submitted some changes to blogSettings, proceed now.
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->saveSettings());  
		  $ret['template']=BLOG_SETTINGS_RESPONSE; 
	       }
	       break;
	    case "save": // Admin has uploaded picture, proceed now.
	       if($this->accessError()) $ok=FALSE;
	       else {
		  $ret['assign']=array('img' => $this->saveNewFile($_FILES));  
		  $ret['template']=UPLOAD_PICTURE_RESPONSE; 
	       }
	       break;
	    case "index": // Show single picture
	       $this->getTag ?  
	       $ret['assign']=array('img' => $this->index($this->getTag)) : 
	       $ret['assign']=array('img' => $this->index());
	       $ret['template']=ARCHIVE;
	       break;
	    case "show": // Show single picture
	    default: 
	       $this->getTag ?
	       $ret['assign']=array('img' => $this->show($this->getPhotoId,$this->getTag)) :
	       $ret['assign']=array('img' => $this->show($this->getPhotoId)) ;
	       $ret['template']=LARGE_PICTURE;
	       break;
	 }
	 return ($ok ? $ret : FALSE);
      }

      public function printUploadForm()
      {
	 $img=array();
	 $currentDate=date("Y-m-d",time());
	 $img['date']=$currentDate;
	 $img['post_max_size']=ini_get('post_max_size');
	 $img['upload_max_filesize']=ini_get('upload_max_filesize');
	 return $img;
      }



      // The Constructor
      public function AtomPhotoBlog($p)
      {
	 global $salt;
	 foreach($p as $key => $value) $this->$key=$value;

	 if($this->doSession)
	 {
	    $this->admin = new Admin(
	       array(
		  "SALT"=>$salt,
		  "SESSIONNAME"=>"apb",
		  "FILE"=>$this->rootPath."/apbData/apbpw.php",
		  "FAILLOG"=>$this->rootPath."/apbData/apb.log",
		  "LOGINURL"=>$_SERVER['PHP_SELF'],
		  "LOGOUTURL"=>$_SERVER['PHP_SELF']
	       )
	    );
	    $this->access=$this->admin->checkAccess();
	    $this->isSessionStarted=TRUE;
	 }
	 $this->getVarsFromBrowser();

	 $this->atomFile=$this->picPath."/atom.xml";
	 $this->atomFileUrl =$this->picUrl."/atom.xml";
	 /* Set properties of the Rss-Feed Object */
	 $this->atomProperties['feedTitle']=$this->blogTitle;
	 $this->atomProperties['feedSubtitle']=$this->blogSubTitle;
	 $this->atomProperties['feedOwner']=$this->blogOwner;
	 $this->atomProperties['feedOwnerEmail']=$this->blogOwnerEmail;
	 $this->atomProperties['feedFile']=$this->atomFile;
	 $this->atomProperties['feedFileUrl']=$this->atomFileUrl;
	 $this->atomProperties['feedRootUrl']=$this->rootUrl;


	 $this->rssFile=$this->picPath."/rss.xml";
	 $this->rssFileUrl =$this->picUrl."/rss.xml";
	 /* Set properties of the Rss-Feed Object */
	 $this->rssProperties['feedTitle']=$this->blogTitle;
	 $this->rssProperties['feedSubtitle']=$this->blogSubTitle;
	 $this->rssProperties['feedOwner']=$this->blogOwner;
	 $this->rssProperties['feedOwnerEmail']=$this->blogOwnerEmail;
	 $this->rssProperties['feedFile']=$this->rssFile;
	 $this->rssProperties['feedFileUrl']=$this->rssFileUrl;
	 $this->rssProperties['feedRootUrl']=$this->rootUrl;

	 return ;
      }

      /*!
      The main show-the-big image method. It has two arguments. The first
      one is an integer that provides the MySQL-Id of the image to show.
      The second one provides the TAG selected. Both are being initialized
      by default to impossible values (-1, and "9x98ex9MAGIC") in order to
      perform default stuff (=show the latest image).
      */
      public function show($thisId=-1,$selTag="9x98ex9MAGIC")
      {
	 $this->mysqlConnect();
	 $img['showImage']=TRUE;

	 if($selTag=="9x98ex9MAGIC") // Select all
	 {
	    $query[1]="select max(microTimeStamp) from ".$this->apbPrefix."entries ";
	    $query[2]="select * from ".$this->apbPrefix."entries where microTimeStamp= ";
	    $query[3]="select * from ".$this->apbPrefix."entries where id=";
	    $query[4]="select min(microTimeStamp) from ".$this->apbPrefix."entries ";
	    $query[5]="select * from ".$this->apbPrefix."entries where microTimeStamp=";
	    $query[6]="select max(microTimeStamp) from ".$this->apbPrefix."entries";
	    $query[7]="select * from ".$this->apbPrefix."entries where microTimeStamp=";
	    $query[8]="select * from ".$this->apbPrefix."entries order by microTimeStamp asc;";
	    $tagLink="";
	 } else  // Only select tagged
	 {
	    $tagQuery =$this->getSelectedTagString($selTag);

	    if(!$tagQuery) { return $img['showImage']=FALSE; }
	    $query[1]="select max(microTimeStamp) from ".$this->apbPrefix."entries where ($tagQuery) ";
	    $query[2]="select * from ".$this->apbPrefix."entries where microTimeStamp= ";
	    $query[3]="select * from ".$this->apbPrefix."entries where id=";
	    $query[4]="select min(microTimeStamp) from ".$this->apbPrefix."entries where ($tagQuery) ";
	    $query[5]="select * from ".$this->apbPrefix."entries where microTimeStamp=";
	    $query[6]="select max(microTimeStamp) from ".$this->apbPrefix."entries where ($tagQuery) ";
	    $query[7]="select * from ".$this->apbPrefix."entries where microTimeStamp=";
	    $query[8]="select * from ".$this->apbPrefix."entries where ($tagQuery) order by microTimeStamp asc;";
	    $tagLink="&amp;tag=".$selTag;
	 }

	 if($thisId==-1)
	 {
	    $buffer=$this->mysqlQuery($query[1]);
	    $buffer=mysql_fetch_array($buffer); $thisT=$buffer[0]; // Last Entry's id?
	    if(!$thisT) return  $img['showImage']=FALSE;  
	    $buffer=mysql_fetch_assoc($this->mysqlQuery($query[2].$thisT)); $thisId=$buffer['id'];
	 }

	 $thisE =mysql_fetch_assoc($this->mysqlQuery($query[3].$thisId));

	 if(!$thisE) return $img['showImage']=FALSE; 
	 // Oldest Entry's id?
	 $buffer=mysql_fetch_array($this->mysqlQuery($query[4])); $oldestT=$buffer[0];
	 $buffer=mysql_fetch_assoc($this->mysqlQuery($query[5].$oldestT)); $oldestId=$buffer['id'];

	 // Latest Entry's id?
	 $buffer=mysql_fetch_array($this->mysqlQuery($query[6])); $latestT=$buffer[0];
	 $buffer=mysql_fetch_assoc($this->mysqlQuery($query[7].$latestT)); $latestId=$buffer['id'];

	 // Next Entry's id?
	 $buffer=$this->mysqlQuery($query[8]);
	 $finished=FALSE;
	 while (!$finished && $row= mysql_fetch_assoc($buffer))
	 {
	    if ($row['id'] == $thisId )
	    {
	       if ($oldestId!=$thisId)
	       {
		  $prevId=$rem['id'];
		  $prevTn=$rem['tnLink'];
		  $prevTit=$rem['title'];
	       }
	       if ($latestId!=$thisId)
	       {
		  $row=mysql_fetch_assoc($buffer);
		  $nextId=$row['id'];
		  $nextTn=$row['tnLink'];
		  $nextTit=$row['title'];
	       }
	       $finished=TRUE;
	    }
	    $rem['id']=$row['id'];
	    $rem['microTimeStamp']=$row['microTimeStamp'];
	    $rem['tnLink']=$row['tnLink'];
	    $rem['title']=$row['tnLink'];
	 }

	 $url=$thisE['picLink'];
	 $alt=$title=$thisE['title'];
	 $comment=$thisE['comment'];
	 $customTimeStamp=$thisE['customTimeStamp'];
	 $hits=$thisE['hits'];
	 $hits++;

	 // IncreaseCounter
	 $this->mysqlQuery("update ".$this->apbPrefix."entries set hits=".$hits." where id=".$thisId);

	 // Prepare the navi-array
	 $this->navi=array(
	    "thisId" =>$thisId,
	    "oldestId" =>$oldestId,
	    "latestId" =>$latestId,
	    "tagLink" =>$tagLink
	 );
	 if (isset($prevId)) $this->navi['prevId']=$prevId;
	 if (isset($nextId)) $this->navi['nextId']=$nextId;

	 // Determine which navigator buttons to show
	 // Oldest Button
	 ($this->navi['thisId'] != $this->navi['oldestId']) ?  $this->navi['ShowOldestButton']=TRUE : $this->navi['ShowOldestButton']=FALSE ;

	 // Previous Button
	 ($this->navi['thisId'] != $this->navi['oldestId']) ? $this->navi['ShowPreviousButton']=TRUE : $this->navi['ShowOldestButton']=FALSE ;

	 // Next Button
	 ($this->navi['thisId'] != $this->navi['latestId'])  ? $this->navi['ShowNextButton']=TRUE : $this->navi['ShowNextButton']=FALSE ;

	 // Latest Button
	 ($this->navi['thisId'] != $this->navi['latestId']) ? $this->navi['ShowLatestButton']=TRUE : $this->navi['ShowLatestButton']=FALSE ; 


	 // Any comments available, at all?
	 $query="select * from ".$this->apbPrefix."comments where entryId= ".$thisId." order by timeStamp desc";
	 $buffer=$this->mysqlQuery($query);
	 $nComments=mysql_num_rows($buffer);
	 $img['comments']=array();
	 if ($nComments>0)
	 {
	    // Any *approved* comments available?
	    $query="select * from ".$this->apbPrefix."comments where entryId= ".$thisId." and approved=1";
	    if(mysql_num_rows($this->mysqlQuery($query)))
	    {
	       while ($cE = mysql_fetch_assoc($buffer))
	       {
		  if($cE['approved']==1)
		  {
		     array_push($img['comments'],$cE);
		  }
	       }
	    }
	 }

	 $this->mysqlDisconnect();

	 // Prepare return array
	 $img['navi']=$this->navi; // This is an Array
	 $img['thisId']=$thisId; // This is an Array
	 $img['alt']=$alt;
	 $img['url']=$url;
	 $img['title']=$title;
	 $img['date']=date("d-m-Y ",$customTimeStamp);
	 $img['hits']=$hits;
	 $img['description']=$comment;
	 $img['nComments']=$nComments;
	 $img['request_uri']=urlencode($_SERVER['REQUEST_URI']);

	 return $img;
      }


      /*!
      Just a method called by the Captcha member. Ignore this, please.
      */
      private function encryptCap($string, $key)
      {
	 $result = '';
	 for($i=0; $i<strlen($string); $i++) {
	    $char = substr($string, $i, 1);
	    $keychar = substr($key, ($i % strlen($key))-1, 1);
	    $char = chr(ord($char)+ord($keychar));
	    $result.=$char;
	 }
	 return base64_encode($result);
      }

      /*!
      Print the <div> that provides a list of all available tags.
      */
      public function getTags($connectMyselfToMysql=TRUE)
      {
	 if($connectMyselfToMysql) $this->mysqlConnect();
	 $buffer=$this->mysqlQuery("select * from ".$this->apbPrefix."tags");
	 $nTags=mysql_num_rows($buffer);
	 $tagList=array();

	 if($nTags >= 1)
	 {
	    while ($tagEntry = mysql_fetch_assoc($buffer))
	    {
	       // we need tagNames to create the unique and sorted tag-list
	       $tagNames[$tagEntry['id']]=$tagEntry['tag'];
	    }

	    $tagNames=(array_unique($tagNames));
	    asort($tagNames);

	    foreach ($tagNames as $tag)
	    {
	       array_push($tagList,urlencode($tag));
	    }
	 }

	 if($connectMyselfToMysql) $this->mysqlDisconnect();
	 return $tagList;
      }


      /*!
      For a selected tag (argument of this member),
      return the tag Id.
      Connection to mysql-Server MUST have been established BEFORE
      calling this method.
      */
      private function getSelectedTagString($selTag)
      {


	 $query="select * from ".$this->apbPrefix."tags where tag=\"$selTag\";";
	 $buffer=false;
	 $buffer=$this->mysqlQuery($query);

	 if($buffer) $nPics=mysql_num_rows($buffer);
	 if ($nPics == 0)
	 {
	    //echo "No pictures tagged &quot;$selTag&quot; available...";
	    return;
	 } else
	 {
	    $k=1;
	    $selTagId="";
	    while ($entry = mysql_fetch_assoc($buffer))
	    {
	       $selTagId.="id=".$entry['entryId'];
	       if(($k++ != $nPics) ) $selTagId.=" or ";
	    }
	 }
	 return $selTagId;
      }

      /*!
      Show the index, archive, or browser of all your images ($selTag=MAGIC)
      or of a certain tag, that is given by the only argument of this method.
      */
      public function index($selTag="9x98ex9MAGIC")
      {
	 $pCount=0; // Column counter

	 $this->mysqlConnect();

	 if($selTag=="9x98ex9MAGIC") // Select all
	 {
	    $query="select * from ".$this->apbPrefix."entries order by microTimeStamp desc;";
	 } else // Only select tagged
	 {
	    $tagQuery=$this->getSelectedTagString($selTag);
	    if(!$tagQuery) { return -1; };
	    $query="select * from ".$this->apbPrefix."entries where ";
	    $query.=$tagQuery;
	    $query.=" order by microTimeStamp desc;";
	 }

	 $buffer=$this->mysqlQuery($query);
	 if($buffer) $nPics=mysql_num_rows($buffer);

	 $img['nPics']=$nPics;
	 $img['showTitleInIndex']=$this->showTitleInIndex;
	 $img['selTag']=$selTag;
	 $img['images']=array();
	 $img['thumbnail']=array();


	 if ($nPics < $this->maxCols) $img['maxCols']=$nPics;
	 else $img['maxCols']=$this->maxCols;

	 /* To Do: Add limited pictures per page ("maxRows") 
	 if ( $nPics / $this->maxCols < $this->maxRows )
	    $img['maxRows'] = ceil($nPics / $this->maxCols);
	 else $img['maxRows']=$this->maxRows;
	 */
	 $img['maxRows']=$this->maxRows;

	 if ($nPics > 0)
	 {
	    while ($entry = mysql_fetch_assoc($buffer))
	    {
	       $thisImage['url']=$entry['picLink'];
	       $thisImage['title']=$entry['title'];
	       $thisImage['alt']=$entry['title'];
	       $thisImage['pId']=$entry['id'];
	       $thisImage['urlTn']=$entry['tnLink'];
	       array_push($img['images'],$thisImage);

	       $thumbString = '';
	       $thumbString .= '			      <table class="apb archive thumbnail" id="abpPic'.$entry['id'].'">';
	       $thumbString .= '			      <tr class="apb archive thumbnail">';
	       $thumbString .= '			      <td class="apb archive thumbnail">';
	       $thumbString .= '				      <a class="apb archive thumbnail" href="'.$this->mainScript.'?do=show&amp;photoId='.$entry['id'].'">';
	       $thumbString .= '					  <img class="apb archive thumbnail" alt="'.$entry['title'].'" src="'.$entry['tnLink'].'" />';
	       $thumbString .= '				    </a>';
	       $thumbString .= '			      </td>';
	       $thumbString .= '			      </tr>';
	       if ($this->showTitleInIndex) 
	       {
		  $thumbString .= '				      <tr class="apb archive archiveTitle">';
		  $thumbString .= '					      <td class="apb archive archiveTitle">';
		  $thumbString .= $entry['title'];
		  $thumbString .= '					      </td>';
		  $thumbString .= '				      </tr>';
	       }
	       if ($this->access) 
	       {
		  $thumbString .= '				    <tr class="apb archive admin">';
		  $thumbString .= '				    <td class="apb archive admin"> ';
		  $thumbString .= '				    <ul class="apb archive edit admin">';
		  $thumbString .= '				       <li class="apb archive edit admin">';
		  $thumbString .= '					  <a href="'.$this->mainScript.'?do=edit&amp;photoId='.$entry['id'].'">Edit</a>';
		  $thumbString .= '				       </li>';
		  $thumbString .= '				       <li class="apb archive edit admin">';
		  $thumbString .= '					  <a href="'.$this->mainScript.'?do=delete&amp;photoId='.$entry['id'].'">Delete</a>';
		  $thumbString .= '				       </li>';
		  $thumbString .= '				    </ul>';
		  $thumbString .= '				    </td>';
		  $thumbString .= '				    </tr>';
	       }
	       $thumbString .=  '  </table> ';
	       array_push($img['thumbnail'],$thumbString);


	    }
	 }
	 return $img;
      }


      /*!
      React on access-request.
      */
      private function accessError()
      {
	 if(!$this->access)
	 {
	    return TRUE;
	 } else return FALSE;
      }


      /*!
      Parse and errorcheck the data provided by the form for uploading a new picture.
      */
      private function parseUploadForm($tag,$date,$customTime=FALSE)
      {
	 // --------------- Error Check Tag
	 if (preg_match("/[^a-zA-Z0-9 ,]/i",$tag)) die("*** ERROR: Your tag must not contain any other than alphanumeric letters: a-z A-Z and 0-9");

	 // --------------- Date parsing and date error check
	 if($customTime) $currentTime=date("His",$customTime);
	 else $currentTime=date("His",time());

	 $sentDate=explode("-",$date);
	 if (strlen($sentDate[0])>4) die("*** ERROR: Year too long: $sentDate[0]");
	 if (strlen($sentDate[0])<4) die("*** ERROR: Year too short: $sentDate[0]");
	 if (strlen($sentDate[1])<2) $sentDate[1]="0".$sentDate[1];
	 if (strlen($sentDate[1])>2) die("*** ERROR: Month too long: $sentDate[1]");
	 if (strlen($sentDate[2])<2) $sentDate[2]="0".$sentDate[2];
	 if (strlen($sentDate[2])>2) die("*** ERROR: Day too long: $sentDate[2]");
	 $back['customTimeStamp']=mktime(
	    substr($currentTime,0,2),
	    substr($currentTime,2,2),
	    substr($currentTime,4,2),
	    $sentDate[1],
	    $sentDate[2],
	    $sentDate[0]
	 );

	 // Create a microtimestamp that is exactly 16 digits long
	 list($usec, $sec)=explode(" ",microtime());
	 $microTimeStamp=$sec.substr((string) $usec,2,-2);
	 $back['microTimeStamp']=$microTimeStamp;

	 return $back;
      }

      /*!
      Set this classes parameters that deal with the location of the picture.
      The picture-name is assembled using the filename and a certain timestamp.
      Latter is the string argument of this method.
      */
      private function setPicLocation($microTimeStamp)
      {

	 $fileName=$this->fileName;
	 $this->target=$this->picPath."/".$microTimeStamp."-".$fileName;
	 $this->targetTn=$this->picPath."/".$microTimeStamp."-tn_".$fileName;

	 $this->targetUrl=$this->picUrl."/".$microTimeStamp."-".$fileName;
	 $this->targetTnUrl=$this->picUrl."/".$microTimeStamp."-tn_".$fileName;

	 return;
      }


      /**
      Try and save the new file(s), if all errorchecks were passed.
      This method performs all necessary steps like parsing and
      errorchecking, resizing of the image, naming the files,
      updating the feeds and finally, saving and chmodding the
      image and its thumbnail. It depends on the function resizeImage()
      provided by resizeImage.inc.php
      */
      private function saveNewFile($files)
      {
	 $nPictures=0;
	 $img['nPictures']= $nPictures;
	 $img['check']=$files['imgfile']['name'][0];
	 if($files['imgfile']['name'][0]!="")
	 {
	 while(list($key,$value)=each($files['imgfile']['name']))
	 {
	    if(!empty($value))
	    {
	       $fileName=$this->fileName=$value;
	       $source=$files['imgfile']['tmp_name'][$key];
	       $title=$_POST['title'][$key];
	       $comment=$_POST['comment'][$key];
	       $tag=$_POST['tag'][$key];
	       $date=$_POST['date'][$key];

	       $picPath=$this->picPath;

	       $back=$this->parseUploadForm($tag,$date);
	       $microTimeStamp=$back['microTimeStamp'];
	       $customTimeStamp=$back['customTimeStamp'];

	       // Parse Filename
	       preg_match("/(\.\w+)$/",$fileName,$match);
	       $uploadedFileType = strtolower($match[1]);

	       $this->setPicLocation($microTimeStamp);

	       // --------------- RESIZE IMAGE
	       if(is_uploaded_file($source))
	       {
		  $newImageL=resizeImage($fileName,$source, $this->largeImageWidth, $this->largeImageHeight, 95,$this->embedCopyright,$this->blogOwner);
		  $newImageS=resizeImage($fileName,$source, $this->thumbnailWidth, $this->thumbnailHeight , 95,FALSE);

		  switch ($uploadedFileType)
		  {
		     case ".jpg":
		     case ".jpeg":
			imagejpeg($newImageL,$this->target,($this->jpegQuality)-5);
			imagejpeg($newImageS,$this->targetTn,$this->jpegQuality);
			$mime='image/jpeg';
			break;
		     case ".png":
			imagepng($newImageL,$this->target);
			imagepng($newImageS,$this->targetTn);
			$mime='image/png';
			break;
		     case ".gif":
			imagegif($newImageL,$this->target);
			imagegif($newImageS,$this->targetTn);
			$mime='image/gif';
			break;
		     default:
			break;
		  }
		  // Change Access rights
		  if(chmod($this->target, 0644) && chmod($this->targetTn, 0644))
		  ;
		  else echo "*** WARNING: Could not change access rights!";
	       } else die ("*** ERROR: Could not upload image");

	       $entryId=$this->createMysqlEntry($customTimeStamp,$microTimeStamp,$title,$tag,$comment);
	       $this->createAtomEntry($entryId,$title,$comment,$mime);
	       $this->createRssEntry($entryId,$title,$comment);
	       $nPictures++;
	    }
	    // Wait a second, so atom-xml will have a unique timestamp
	    // (If not, some Atom-XML validators might complain)
	    sleep(1);
	 }
	 } 
	 $img['nPictures']=$nPictures;
	 return $img;
      }


      /*!
      Print the form to edit a pictures properties.
      This method is privat, so it MUST be called from a navigator from
      within this object.
      */
      private function printEditForm($getpId)
      {
	 $tagString="";
	 $pId=(int) $getpId;

	 $this->mysqlConnect();
	 $query="select * from ".$this->apbPrefix."entries where id=".$pId;
	 $buffer=$this->mysqlQuery($query);
	 $nPics=mysql_num_rows($buffer);
	 if($nPics)
	 {
	    $entries=mysql_fetch_assoc($buffer);
	    $query="select * from ".$this->apbPrefix."tags where entryId=".$pId;
	    $buffer=$this->mysqlQuery($query);

	    while($tags=mysql_fetch_assoc($buffer)) $tagString.=$tags['tag'].", ";

	    // Replace terminal ,
	    $tagString=substr_replace($tagString,"",strrpos($tagString,","));
	    $img['title']=$entries['title'];
	    $img['tagString']=$tagString;
	    $img['comment']=$entries['comment'];
	    $img['fileName']=$entries['fileName'];
	    $img['pId']=$pId;
	    $img['customDate']=date("Y-m-d",$entries['customTimeStamp']); 
	 } else
	 {
	    echo "ERROR: No picture with Id $pId available!";
	 }

	 $this->mysqlDisconnect();

	 return $img;
      }

      /*!
      Proceed the data sent by the printEdirForm(). This method
      updates the feeds and mysql-database. 
      TODO: Improve Error-handling!
      */
      private function editPicture()
      {
	 $date=$_POST['date'];
	 $tag=$_POST['tag'];
	 $pId=$_POST['pId'];
	 $this->fileName=$_POST['fileName'];
	 $img=array();

	 $microTimeStamp=$this->getMicroTimeStamp($pId);

	 $back=$this->parseUploadForm($tag,$date);
	 $customTimeStamp=$back['customTimeStamp'];

	 // Create Picture Location Parameters of this object
	 $this->setPicLocation($microTimeStamp);

	 $this->editMySQLEntry($pId,$customTimeStamp,$microTimeStamp);
	 $status['atom']=$this->editAtomEntry($pId,$microTimeStamp);
	 $status['rss']=$this->editRssEntry($pId,$microTimeStamp);

	 return $img;
      }


      /*!
      This method deletes a picture. For security reasons, this one is private, too.
      Calling this method comprises updating the feeds and the mysql-db, as well as
      removing the image-files from disk. The only argument is an integer that equals
      the id of the picture in the mysql-db.
      */
      private function deletePicture($getpId)
      {
	 $pId=(int) $getpId;
	 $microTimeStamp=$this->deleteMySQLEntry($pId);

	 $img['error']['mysql']=FALSE;
	 $img['error']['atom']=FALSE;
	 $img['error']['rss']=FALSE;
	 $img['error']['deleteFiles']=FALSE;

	 if(!$microTimeStamp) $img['error']['mysql']=TRUE;
	 else
	 {
	    if(!$this->deleteAtomEntry($microTimeStamp)) $img['error']['atom']=FALSE;
	    if(!$this->deleteRssEntry($microTimeStamp))  $img['error']['rss']=FALSE;
	    if(!$this->deleteFiles($microTimeStamp))  $img['error']['deleteFiles']=FALSE;
	    }
	 return $img;
	 }

      /*!
      Delete image files, called from within AtomPhotoBlog::deletePicture().
      */
      private function deleteFiles($microTimeStamp)
      {
	 $status=FALSE;
	 $fileName=$this->picPath."/".$microTimeStamp.'*';
	 $dh=opendir($this->picPath);
	 while (($entry = readdir($dh) ))
	 {
	    if ( ereg($microTimeStamp,$entry))
	    {
	       $status=TRUE;
	       $fileName=$this->picPath."/".$entry;
	       unlink($fileName);
	    }
	 }
	 return $status;
      }

      private function initRss()
      {
	 $fRss = new FeedRss($this->rssProperties);
	 $fRss->initFeedFile();
      }

      private function initAtom()
      {
	 $fAtom = new FeedAtom($this->atomProperties);
	 $fAtom->initFeedFile();
      }

      private function createAtomData($entryId,$keepAtomId=FALSE,$title,$comment,$mime="")
      {
	 $data['itemTitle']=$title; 
	 $data['link']="http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?do=show&photoId='.$entryId;
	 $data['keepAtomId']=$keepAtomId;
	 $data['enclosureUrl']=$this->targetUrl;
	 $data['enclosureSize']=filesize($this->target);
	 $data['enclosureMimeType']=$mime;
	 $data['imgUrl']=$this->targetUrl;
	 $data['description']=$comment;
	 return $data;
      }

      private function editRssEntry($entryId,$microTimeStamp)
      {
	 $title=$_POST['title'];
	 $comment=$_POST['comment'];

	 $newEntryData=$this->createRssData($entryId,$title,$comment);
	 $fRss = new FeedRss($this->rssProperties);
	 $xPathQuery = '//rss/channel/item/content:encoded[contains(.,"'.$microTimeStamp.'")]';
	 return $fRss->updateEntry($xPathQuery,$newEntryData);
      }

      private function editAtomEntry($entryId,$microTimeStamp)
      {
	 $title=$_POST['title'];
	 $comment=$_POST['comment'];

	 $newEntryData=$this->createAtomData($entryId,TRUE,$title,$comment);
	 $fAtom = new FeedAtom($this->atomProperties);
	 //$xPathQuery = '//pf:feed/pf:entry/pf:id[contains(.,"'.$microTimeStamp.'")]';

	 $xPathQuery = '//pf:feed/pf:entry/pf:link[contains(@href,"'.$microTimeStamp.'")]';
	 return $fAtom->updateEntry($xPathQuery,$newEntryData);
      }

      private function createRssData($entryId,$title,$comment)
      {
	 $cDataString ='<p><a href="http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?do=show&photoId='.$entryId.'"> ';
	 $cDataString.='<img';
	 $cDataString.=' src="'.xmlRecode(utf8_encode($this->targetUrl)).'" ';
	 $cDataString.=' alt="'.xmlRecode(utf8_encode($title)).'"';
	 $cDataString.=' />';
	 $cDataString.='</a></p>';
	 $cDataString.='<p>'.utf8_encode(htmlRecodeLight($comment)).'</p>';

	 $data['itemTitle']=$title; 
	 $data['link']="http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?do=show&amp;photoId='.$entryId;
	 $data['description']=$comment;
	 $data['cDataString']=$cDataString;
	 return $data;
      }

      private function deleteAtomEntry($microTimeStamp)
      {
	 $xPathQuery = '//pf:feed/pf:entry/pf:id[contains(.,"'.$microTimeStamp.'")]';
	 $fAtom = new FeedAtom($this->atomProperties);
	 return $fAtom->deleteEntry($xPathQuery);

      }

      private function deleteRssEntry($microTimeStamp)
      {
	 $xPathQuery = '//rss/channel/item/content:encoded[contains(.,"'.$microTimeStamp.'")]';
	 $fRss = new FeedRss($this->rssProperties);
	 return $fRss->deleteEntry($xPathQuery);
      }


      private function editMySQLEntry($pId,$customTimeStamp,$microTimeStamp)
      {
	 $this->mysqlConnect();

	 // Update Entries Table
	 $rowData=array(
	    "title"=>htmlspecialchars($_POST['title'],ENT_QUOTES),
	    "comment"=>htmlspecialchars($_POST['comment'],ENT_QUOTES),
	    "fileName"=>$this->fileName,
	    "picLink"=>$this->targetUrl,
	    "tnLink"=>$this->targetTnUrl,
	    "time"=>date("H:i:s", $customTimeStamp),
	    "date"=>date("Y-m-d", $customTimeStamp),
	    "year"=>date("Y", $customTimeStamp),
	    "customTimeStamp"=>$customTimeStamp,
	    "microTimeStamp"=>$microTimeStamp,
	    "IP"=>$_SERVER['REMOTE_ADDR']
	 );

	 $where="id=$pId";
	 $this->mysqlUpdateRow($rowData,$this->apbPrefix."entries",$where);


	 // Update Tag Table
	 $query="delete from ".$this->apbPrefix."tags where entryId=$pId";
	 $this->mysqlQuery($query);
	 $this->mysqlStoreTag(htmlRecode($_POST['tag']),$pId);

	 $this->mysqlDisconnect();
	 return;
      }

      private function getMicroTimeStamp($pId)
      {
	 $this->mysqlConnect();

	 $query="select * from ".$this->apbPrefix."entries where id=".$pId;
	 $buffer=$this->mysqlQuery($query);

	 $thisPic=mysql_fetch_assoc($buffer);
	 $microTimeStamp=$thisPic['microTimeStamp'];

	 $this->mysqlDisconnect();
	 return $microTimeStamp;

      }

      private function deleteMySQLEntry($pId)
      {
	 $this->mysqlConnect();


	 $query="select * from ".$this->apbPrefix."entries where id=".$pId;

	 $buffer=$this->mysqlQuery($query);

	 $nPics=mysql_num_rows($buffer);
	 if($nPics)
	 {
	    $thisPic=mysql_fetch_assoc($buffer);
	    $microTimeStamp=$thisPic['microTimeStamp'];

	    $query="delete from ".$this->apbPrefix."entries where id=".$pId;
	    $buffer=$this->mysqlQuery($query);

	    $query="delete from ".$this->apbPrefix."tags where entryId=".$pId;
	    $buffer=$this->mysqlQuery($query);

	    $query="delete from ".$this->apbPrefix."comments where entryId=".$pId;
	    $buffer=$this->mysqlQuery($query);
	 } 
	 
	 /* TODO: Return this error by errorcode
	 else
	 {
	    echo "<p class=\"apb error \">ERROR: No picture with Id $pId available!</p>";
	 }
	 */

	 $this->mysqlDisconnect();

	 return $microTimeStamp;
      }

      private function createMysqlEntry($customTimeStamp,$microTimeStamp,$title,$tag,$comment)
      {
	 // Cosmetic String Stuff

	 //	 $cleanTitle=htmlRecode($title);
	 //	 $cleanComment=htmlRecode($comment);
	 $cleanTag=htmlRecode($tag);


	 // --------------- Create MySQL Entry
	 $queryEntry=array(
	    "title"=>htmlspecialchars($title,ENT_QUOTES),
	    "comment"=>htmlspecialchars($comment,ENT_QUOTES),
	    "fileName"=>$this->fileName,
	    "picLink"=>$this->targetUrl,
	    "tnLink"=>$this->targetTnUrl,
	    "time"=>date("H:i:s", $customTimeStamp),
	    "date"=>date("Y-m-d", $customTimeStamp),
	    "year"=>date("Y", $customTimeStamp),
	    "customTimeStamp"=>$customTimeStamp,
	    "microTimeStamp"=>$microTimeStamp,
	    "IP"=>$_SERVER['REMOTE_ADDR']
	 );

	 $this->mysqlConnect();
	 $this->mysqlStoreRow($queryEntry,$this->apbPrefix.'entries');

	 // Find out the id of the entry that was store to associate with tags to store
	 $buffer=$this->mysqlQuery('select id from `'.$this->apbPrefix.'entries` where microTimeStamp="'.$microTimeStamp.'";');
	 if($buffer)	 $buffer=mysql_fetch_assoc($buffer);
	 $entryId=$buffer['id'];

	 // Store the tags
	 $this->mysqlStoreTag($cleanTag,$entryId);
	 $this->mysqlDisconnect();
	 return $entryId;
      }

      private function mysqlStoreTag($cleanTag,$entryId)
      {
	 $tagArray=explode(",",$cleanTag); // Disassemble Tags
	 foreach($tagArray as $tag)
	 {
	    $tag=trim($tag);
	    if(preg_match("/[a-zA-Z0-9 ]/i", $tag))
	    {
	       $queryTag=array(
		  "tag"=>$tag,
		  "entryId"=>$entryId
	       );
	       $this->mysqlStoreRow($queryTag,$this->apbPrefix.'tags');
	    } else if($tag != '') echo "*** WARNING: Tag '".$tag."' was NOT saved in mysqlDB.";
	 }

	 return;
      }

      private function createRssEntry($entryId,$title,$data)
      {
	 $newEntryData=$this->createRssData($entryId,$title,$data);
	 $fRss = new FeedRss($this->rssProperties);
	 $fRss->createEntry($newEntryData);
      }

      private function createAtomEntry($entryId,$title,$comment,$mime="")
      { 
	 $newEntryData=$this->createAtomData($entryId,FALSE,$title,$comment,$mime);
	 $fAtom = new FeedAtom($this->atomProperties);
	 $fAtom->createEntry($newEntryData);
      }

      private function approveComments()
      {
	 $this->mysqlConnect();
	 $selection='where approved=0';
	 $buffer=$this->mysqlQuery("SELECT * FROM  `".$this->apbPrefix."comments` ".$selection." order by timeStamp asc")
	 or die("*** ERROR: Reading Comments-Table failed.");
	 $img['row']=array();

	 $img['nComments']= mysql_num_rows($buffer);
	 while ($row = mysql_fetch_assoc($buffer))
	 {
	    $entry=mysql_fetch_assoc($this->mysqlQuery("SELECT  tnLink, title FROM  `".$this->apbPrefix."entries` where id=".$row['entryId']));
	    $row['entry']=$entry;
	    array_push($img['row'],$row);
	 }

	 mysql_free_result($buffer);
	 $this->mysqlDisconnect();
	 return $img;
      }


      /*!
      Security (Captcha) and Errorcheck the comment sent by comment form. 
      If o.k, store it for approvement by the admin.
      */
      private function saveComment()
      {
	 $error=FALSE;
	 $img['noMyCap']=FALSE;
	 $img['error']=FALSE;
	 $errorList=array();

	 if(!isset($_SESSION['apbMyCap'])) return $img['noMyCap']=TRUE;

	 // Error Check
	 if(trim($_POST['posterComment']==""))
	 {
	    $error=TRUE;
	    $errorList['NO COMMENT']="Your comment contains no text.";
	 }
	 if(trim($_POST['posterName']==""))
	 {
	    $error=TRUE;
	    $errorList['NO NAME']="Your name field contains no text.";
	 }

	 // Wordlist check
	 $val = new CheckContent("./apbData/pbblacklist.txt");
	 if(
	    (!($val->validate($_POST['posterComment'])))
	    ||
	    (!($val->validate($_POST['posterName'])))
	 )
	 {
	    $error=TRUE;
	    $errorList['INVALID CONTENT']="Your entry contains abusive words.";
	 }

	 // Captcha Check
	 $sec= $this->encryptCap($_POST["secCode"], "jf9wqf82frh");
	 $sec=str_replace("=", "", $sec);
	 if($sec != $_SESSION['apbMyCap'])
	 {
	    $error=TRUE;
	    $errorList['CAPTCHA']="You did not enter the security code correctly.";
	 }

	 $img['error']=$error;
	 $img['errorList']=$errorList;

	 if (!$error)
	 {
	    unset($_SESSION['apbMyCap']);

	    if(isset($_POST['posterHomepage']) 
	    && trim($_POST['posterHomepage']) != ""
	    && trim($_POST['posterHomepage']) != "http://")
	    $homepage=trim($_POST['posterHomepage']);

	    $this->mysqlConnect();

	    // Create Array
	    $rowData=array(
	       "homepage" => strip_tags($homepage),
	       "comment" => strip_tags($_POST['posterComment']),
	       "email" => strip_tags($_POST['posterEmail']),
	       "name" => strip_tags($_POST['posterName']),
	       "entryId" => $_POST['posterId'],
	       "IP" => $_SERVER["REMOTE_ADDR"]
	    );
	    $this->mysqlStoreRow($rowData,$this->apbPrefix.'comments');
	    $this->mysqlDisconnect();
	    $img['posterThisShow']=urldecode($_POST['posterThisShow']);

	    /* Notify admin */
	    $message = "Dear ".$this->blogOwner.",\n\n";
	    $message .= "A comment was submitted to your photoblog by ";
	    $message .= $_POST['posterName']." (IP: ".$_SERVER["REMOTE_ADDR"];
	    $message .= ", E-Mail: ".$_POST['posterEmail'];
	    $message .= "). The message text is:\n\n";
	    $message .=  $_POST['posterComment']."\n";
	    $message .= "\nWith respect to security, you will have to go to your photoblog, login as admin";
	    $message .= "and approve this comment, before it becomes visible to the public.\n";

	    mail($this->blogOwnerEmail,"New Message From Your Photoblog",$message);
	 }
	 return $img;
      }



      /*!
      If admin has sent the form, this method is called in order to save approvements.
      */
      private function doApprove()
      {

	 $approve=array();
	 $reject=array();
	 // Parse form
	 foreach ($_POST as $key => $value)
	 {
	    switch($value)
	    {
	       case 'approve':
		  array_push($approve,$key);
		  break;
	       case 'reject':
		  array_push($reject,$key);
		  break;
	    }
	 }

	 $this->mysqlConnect();

	 if(count($approve))
	 {
	    $query = "update `".$this->apbPrefix."comments` set approved=1 where ";
	    $i=1;
	    foreach ($approve as $value)
	    {
	       $query .= "id=$value";
	       if($i++<count($approve)) $query .=" or ";
	    }
	    $this->mysqlQuery($query) or die('*** ERROR: Approvement Query failed');


	 }

	 if(count($reject))
	 {
	    $query = "delete from `".$this->apbPrefix."comments` where ";
	    $i=1;
	    foreach ($reject as $value)
	    {
	       $query .= "id=$value ";
	       if($i++<count($reject)) $query .=" or ";
	    }
	    $this->mysqlQuery($query) or die('*** ERROR: Rejection Query failed');
	 }
	 $img['approved']=count($approve);
	 $img['rejected']=count($reject);

	 $this->mysqlDisconnect();
	 return $img;
      }
   }
?>
