<?php
   /*
   CheckContent distributed with AtomPhotoBlog.
   Version 1.0
   (c) 2007 by S TAYEFEH

   Check string for illegal stuff.
   The constructur needs one single string argument, that contains the
   URI to the blacklist.txt file. This list contains one word per line of
   words that must not occur in the string to validate.

   Example use:

      require_once "CheckContent.php";
      $val = new CheckContent("pbblacklist.txt");
      if ($val->validate("ueh i hiru hrie wiu hwiu hwitu")) echo "ok";
      else echo "failed";


   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


   */

   class CheckContent
   {
      public $blacklistFN; // The textfile with the list of prohibited expressions
      public $content="";  // The content to check - A single string
      private $blacklistA=array();
      private $isValid=TRUE;

      // constructor
      public function CheckContent($blacklist)
      {
	 $this->isValid=TRUE;
	 $this->blacklistFN=$blacklist;
	 $this->content="EMPTY";
      }

      // Main Method
      public function validate($content)
      {
	 $this->content=$content;
	 if(!$this->readFile()) return FALSE;

	 foreach ($this->blacklistA as $a)
	 {
	    if(preg_match('/'.$a.'/i',$content)) $this->isValid=FALSE;
	 }
	 return $this->isValid;
      }

      // Read File
      private function readFile()
      {
	 $blacklistTemp=array();
	 $blacklistS=FALSE;
	 $blacklistS=file_get_contents($this->blacklistFN);
	 if (!$blacklistS) 
	  {
	     echo "*** ERROR from CheckContent:: - Could not read blacklist file: ".$this->blacklistFN;
	     return FALSE;
	  }
	 $blacklistTemp=explode("\n",$blacklistS);
	 // Clean array
	 $this->blacklistA=array();
	 // Only lines that contain letters or digits
	 foreach ($blacklistTemp as $a) if( ereg("[a-zA-Z0-9]",$a) ) array_push($this->blacklistA,trim($a));
	 sort($this->blacklistA); // Cosmetic ;-)
	 return TRUE;
      }
   }

