<?php

   /*
   codeCleaner.inc.php distributed with AtomPhotoBlog.
   Version 0.9.0
   2007 by S. Tayefeh

   Even though PHP provided e.g. htmlentities(), we declare our own 
   html- and xml-replace function. This is mainly for three reasons:
   1. We need to refine the replacement in order to cope with atom feeds ;-)
   2. It is not for sure that the client makes use of utf-8.
   3. The server replaces ' by \' in order to prevent code-injection.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

   */


   $replaceHtml=array(
      '\"'=>'"',
      "\'"=>"'",
      "&"=>"&amp;"
   );

   $replaceXml=array(
      "<"=>"&lt;",
      ">"=>"&gt;",
      "&"=>"&amp;",
      "'"=>"&apos;",
      '"'=>"&quot;"
   );

   $replaceXmlLight=array(
      '\"'=>'"',
      "\'"=>"'"
   );

   function htmlRecode($string)
   {
      global $replaceHtml, $replaceXml, $replaceXmlLight;
      $string= str_replace(array_keys($replaceHtml),array_values($replaceHtml),$string);
      $string=htmlentities($string);
      return $string;
   }


   function htmlRecodeLight($string)
   {
      global $replaceHtml, $replaceXml, $replaceXmlLight;
      return str_replace(array_keys($replaceHtml),array_values($replaceHtml),$string);
   }



   function xmlRecode($string)
   {
      global $replaceHtml, $replaceXml, $replaceXmlLight;
      $string=str_replace(array_keys($replaceXmlLight),array_values($replaceXmlLight),$string);
      $string=str_replace(array_keys($replaceXml),array_values($replaceXml),$string);
      return $string;
   }


   function xmlRecodeLight($string)
   {
      global $replaceHtml, $replaceXml, $replaceXmlLight;
      $string=str_replace(array_keys($replaceXmlLight),array_values($replaceXmlLight),$string);
      return $string;
   }

?>
