<?php
/*
   Atom PhotoBlog - PHP5 based photo-blogger
   Version 1.1.5b1
   Copyright (C) 2007 by Sascha Tayefeh
   http://www.tayefeh.de

   Smarty(TM) is not part of this code, but is maintained by 
   New Digital Group, Inc. and copyright 2001-2005 New Digital Group, Inc.
   See http://smarty.php.net/
 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*! \brief Sample template main-page.

	This is the main-page of AtomPhotoBlog that serves as a starting-point
	for your own creativity. Please, carefully read the comments, so you
	can understand what they do and what you need to adapt in order to
	design this blog to your needs.
*/
require_once './apbData/vars.php'; 
require_once './apbClasses/templateFileNames.inc.php'; 
require_once './apbClasses/AtomPhotoBlog.class.php';
require_once './apbClasses/SmartyAPB.class.php'; 

$blog = new AtomPhotoBlog($apbPara); // There MUST NOT be ANY html-code before this line!!!
$apbPara['atomFileUrl']=$blog->atomFileUrl;
$apbPara['rssFileUrl']=$blog->rssFileUrl;
$apbPara['cssFileUrl']=$blog->styleSheet;
$apbPara['htmlEncoding']=$blog->htmlEncoding;
$apbPara['maxRows']=$blog->maxRows;


$smarty = new SmartyAPB($apbPara);

$smarty->assign('apbPara',$apbPara);
$smarty->assign('adminAccess',$blog->access);
$smarty->assign('mainScript',$apbPara['rootPath']."/atomPhotoBlog.php");
$smarty->assign('mainScript',$_SERVER['PHP_SELF']);
$smRet=$blog->selectTemplateContent();
$tagList=$blog->getTags();

if($smRet)
{
   $smarty->assign('content',$smRet['template']);
   if(isset($smRet['assign'])) foreach($smRet['assign'] as $key => $value) $smarty->assign($key,$value);
   $smarty->assign('tagList',$tagList);
} else {
   $smarty->assign('content',ACCESS_DENIED);
}

$smarty->display('main.tpl');

?>
